%define		pname apf
%define		mversion 0.9.4
%define		pversion 0.9.4
%define 	bversion 7
%define		rpmrelease iworx

%define		basedir /etc/apf
%define		binpath /usr/local/sbin/apf
%define		compat_binpath /usr/local/sbin/fwmgr

%define 	debug_package %{nil}

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command 
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#


%define 	build_mdk_72   0
%define 	build_mdk_80   0
%define 	build_mdk_81   0
%define 	build_mdk_82   0
%define 	build_mdk_90   0
%define		build_mdk_91   0
%define		build_mdk_92   0
%define 	build_rht_7x   0
%define 	build_rht_80   0
%define 	build_rht_90   0
%define 	build_sus_7x   0
%define 	build_sus_80   0
%define 	build_trustix  0
%define		build_cos_3x   0
%define		build_fdr_10   0
%define		build_fdr_20   0
%define		build_whb_3x   0
%define		build_rhe_2x   0
%define		build_rhe_3x   0

%define		build_unk      1

# Command Line Overrides
%{?_with_mdk72:   	%{expand: %%define build_mdk_72   1}}
%{?_with_mdk80:   	%{expand: %%define build_mdk_80   1}}
%{?_with_mdk81:   	%{expand: %%define build_mdk_81   1}}
%{?_with_mdk82:   	%{expand: %%define build_mdk_82   1}}
%{?_with_mdk90:   	%{expand: %%define build_mdk_90   1}}
%{?_with_mdk91:   	%{expand: %%define build_mdk_91   1}}
%{?_with_mdk92:   	%{expand: %%define build_mdk_92   1}}
%{?_with_rht7x:   	%{expand: %%define build_rht_7x   1}}
%{?_with_rht80:   	%{expand: %%define build_rht_80   1}}
%{?_with_rht90:   	%{expand: %%define build_rht_90   1}}
%{?_with_sus7x:   	%{expand: %%define build_sus_7x   1}}
%{?_with_sus80:   	%{expand: %%define build_sus_80   1}}
%{?_with_trustix: 	%{expand: %%define build_trustix  1}}
%{?_with_cos3x: 	%{expand: %%define build_cos_3x   1}}
%{?_with_fdr10: 	%{expand: %%define build_fdr_10   1}}
%{?_with_fdr20: 	%{expand: %%define build_fdr_20   1}}
%{?_with_whb3x: 	%{expand: %%define build_whb_3x   1}}
%{?_with_rhe2x: 	%{expand: %%define build_rhe_2x   1}}
%{?_with_rhe3x: 	%{expand: %%define build_rhe_3x   1}}

%{?_with_unk: 		%{expand: %%define build_unk      1}}

# Distro Statements
%if %{build_mdk_92}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype GNU/Linux Mandrake 9.2
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_mdk_91}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype GNU/Linux Mandrake 9.1
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_mdk_90}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype GNU/Linux Mandrake 9.0
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_mdk_82}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype GNU/Linux Mandrake 8.2
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_mdk_81}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype GNU/Linux Mandrake 8.1
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_mdk_80}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype GNU/Linux Mandrake 8.0
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_mdk_72}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype GNU/Linux Mandrake 7.2
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rht_7x}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype RedHat 7.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rht_80}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype RedHat 8.0
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rht_90}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype RedHat 9
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_sus_7x}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Suse Linux 7.x Series
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_sus_80}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Suse Linux 8.0
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_trustix}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Linux Trustix
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_cos_3x}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype CentOS 3.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_10}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Fedora Core 1
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_20}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Fedora Core 2
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_whb_3x}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype White Box 3.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_2x}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype RedHat Enterprise 2.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_3x}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype RedHat Enterprise 3.x
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Unknown Distribution
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

############### RPM ################################

Summary:	APF - Advanced Policy Firewall
Name:		%{pname}
Version:	%{pversion}
Release: 	%{release}
License:	GPL

Group:		System Environment/Daemons
Source0:	%{name}-current.tar.gz
URL:		http://www.rfxnetworks.com/apf.php

Distribution:	InterWorx-HAL
Vendor:         NEXCESS.NET L.L.C
Packager:	Chris Wells <clwells@nexcess.net>

BuildRoot:	%{_tmppath}/%{name}-%{version}-root

BuildArch:	noarch

Requires:	iptables

%description
APF is a policy based iptables firewall system designed for ease 
of use and configuration. It employs a subset of features to satisfy
the veteran Linux user and the novice alike. Packaged in tar.gz format 
and RPM formats, make APF ideal for deployment in many server 
environments based on Linux.

%prep

[ -n %{buildroot} ] && rm -rf %{buildroot}

[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}

%setup -q -n %{name}-%{version}-%{bversion}

# Try detecting newest gcc (some distributions have got more then one compiler)
# and write it on a temp file 

[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{name}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{name}-%{pversion}-gcc
fi

# Display compilation flags and OS with colors ;)

[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags

# We have gcc written in a temp file
export CC="`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
export CFLAGS="%{ccflags}"
export LDFLAGS="%{ldflags}"

# Delete gcc temp file
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

%build

%install

mkdir -p %{buildroot}%{basedir}
cp -R files/* %{buildroot}%{basedir}
find %{buildroot}%{basedir} -type f \-exec chmod 640 {} \;
find %{buildroot}%{basedir} -type d \-exec chmod 750 {} \;
cp README README.antidos CHANGELOG COPYING.GPL %{buildroot}%{basedir}/doc

mkdir -p %{buildroot}%{_sysconfdir}/cron.daily
mkdir -p %{buildroot}%{_sysconfdir}/init.d
mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d

install -m 0700 cron.daily 	%{buildroot}%{_sysconfdir}/cron.daily/fw
install -m 0700 apf.init 	%{buildroot}%{_sysconfdir}/init.d/apf
install -m 0600 logrotate.d.apf %{buildroot}%{_sysconfdir}/logrotate.d/apf

chmod 750 %{buildroot}%{basedir}/apf
chmod 750 %{buildroot}%{basedir}/firewall
chmod 750 %{buildroot}%{basedir}/conf.apf
chmod 750 %{buildroot}%{basedir}/vnet/vnetgen

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}

%pre

%postun

%post

ln -fs %{basedir}/apf %{binpath}
ln -fs %{basedir}/apf %{compat_binpath}

[ -f "%{_sysconfdir}/cron.d/fwdev" ]   && rm -f %{_sysconfdir}/cron.d/fwdev
[ -f "%{basedir}/cron.fwdev" ]         && rm -f %{basedir}/cron.fwdev
[ -f "%{_sysconfdir}/cron.hourly/fw" ] && rm -f %{_sysconfdir}/cron.hourly/fw

if [ -f "/var/log/apf_log" ] || [ -f "/var/log/apfados_log" ]; then
	rm -f /var/log/apf_log /var/log/apfados_log
fi

if [ -f "/sbin/chkconfig" ]; then
	/sbin/chkconfig --add apf
	/sbin/chkconfig --level 345 apf on
fi

%{basedir}/vnet/vnetgen

if [ -f "/usr/bin/dialog" ] && [ -d "%{basedir}/extras/apf-m" ]; then
	pushd %{basedir}/extras/apf-m/
	sh install -i
	popd
fi

%preun

%files
%defattr(-,root,root)
%attr(0750,root,root) %dir %{basedir}
%attr(-,root,root)    %{basedir}/*
%attr(0700,root,root) %{_sysconfdir}/cron.daily/fw
%attr(0700,root,root) %{_sysconfdir}/init.d/apf
%attr(0600,root,root) %{_sysconfdir}/logrotate.d/apf

%changelog
* Sat Oct 23 2004 Chris Wells <clwells@nexcess.net>
- initial release
